#import "BBWeakRef.h"

@implementation BBWeakRef

@synthesize target = _target;

+ (id)refWithTarget:(id)target
{
    return [[BBWeakRef alloc] initWithTarget:target];
}

- (id)initWithTarget:(id)target
{
    self = [super init];

    if (nil != self)
    {
        [self setTarget:target];
    }

    return self;
}

- (NSUInteger)hash
{
    return [[self target] hash];
}

- (BOOL)isEqual:(id)other
{
    if ([other isKindOfClass:[BBWeakRef class]])
    {
        return [[(BBWeakRef *)other target] isEqual:[self target]];
    }
    return NO;
}

@end

